#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101
#define leave(str) {ST_helpMsg(str); push_quantum(NOTHING_TAG); return;}

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer
typedef struct node_t *node, node_t;
struct node_t { int v; node next; };

//Check if the ESI pointer is an integer
short is_positive_integer (ESI ptr)
{
  return (*ptr == POSINT_TAG);
}

void strand_sort(int *ar, int len)
{
	node_t all[len], head, shead, merged, *cur, *next, *stail;
 
	/* linkify */
	int i;
	for (i = 0; i < len; i++) {
		all[i].v = ar[i];
		all[i].next = all + i + 1;
	}
	all[len - 1].next = 0;
	head.next = all;
	shead.next = merged.next = 0;
 
	while (head.next) {
		/* take strand */
		cur = &head;
		stail = shead.next = head.next;
 
		while (next = cur->next) {
			if (next->v >= stail->v) {
				cur->next = next->next;
				stail = stail->next = next;
			} else 
				cur = next;
		}
		stail->next = 0;
 
		/* merge */
		cur = merged.next;
		next = shead.next;
		stail = &merged;
 
		/* while both lists contain elements, append the smaller one */
		while (next && cur) {
			if (next->v <= cur->v) {
				stail = stail->next = next;
				next = next->next;
			} else {
				stail = stail->next = cur;
				cur = cur->next;
			}
		}
		/* append the rest of the survivor to the end of merged */
		stail->next = next ? next : cur;
	}
	cur = &merged;
	len = 0;
	while (cur = cur->next) ar[len++] = cur->v;
}

void _main(void)
{
	ESI argptr = top_estack;
	
	//Yhe first argument of the TIOS function is the length of the list
	VLI dimension = GetLongLongArg(argptr); 
	VLI i = 0;
	
	//The dynamic array
	int* array = (int*) malloc(dimension * sizeof(int));
	
	//If the second argument is a list
	if(*argptr == LIST_TAG) 
	{
		//Check if all elements of the list are integers
		//Argptr must be decremented by one to point to first element of the list
		if(!all_tail(is_positive_integer, --argptr))	
		{
			leave("List elements must be integers >= 0.");
		}
		else
			while(i<dimension && *argptr != END_TAG) array[i++]=GetLongLongArg(argptr);
	}
	
	strand_sort(array, dimension);
	
	push_END_TAG();
	for(i=dimension; i>0; i--) push_longlongint(array[i-1]);
	push_LIST_TAG();
}